//::///////////////////////////////////////////////
//:: Magic Circle Against Evil
//:: NW_S0_CircEvil.nss
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
//:: [Description of File]
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: March 18, 2001
//:://////////////////////////////////////////////
//:: Last Updated By: Preston Watamaniuk, On: April 11, 2001
//:: 6/68/06 - BDF-OEI: updated to use NWN2 VFX

#include "jx_inc_magic"
#include "x2_inc_spellhook" 

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{

/* 
  Spellcast Hook Code 
  Added 2003-06-23 by GeorgZ
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more
  
*/

    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        { JXPostSpellCastCode(); return; }
    }

// End of Spell Cast Hook


    //Declare major variables including Area of Effect Object
   	//effect eVis = EffectVisualEffect(VFX_DUR_PROTECTION_GOOD_MINOR);	// handled by CreateProtectionFromAlignmentLink(); see nw_i0_spells.nss
    //effect eVis = EffectVisualEffect( VFX_DUR_SPELL_EVIL_CIRCLE );	// handled by CreateProtectionFromAlignmentLink(); see nw_i0_spells.nss
    //effect eDur = EffectVisualEffect( VFX_DUR_SPELL_MAGIC_CIRCLE );	// handled by CreateProtectionFromAlignmentLink(); see nw_i0_spells.nss
    //effect eVis2 = EffectVisualEffect(VFX_IMP_GOOD_HELP);	// handled by CreateProtectionFromAlignmentLink(); see nw_i0_spells.nss

    //effect eLink = EffectLinkEffects(eAOE, eDur);
    //eLink = EffectLinkEffects(eLink, eDur);

    object oTarget = JXGetSpellTargetObject();
    int nDuration = JXGetCasterLevel(OBJECT_SELF);
    int nMetaMagic = JXGetMetaMagicFeat();
    //Make sure duration does no equal 0
    if (nDuration < 1)
    {
        nDuration = 1;
    }
    //Check Extend metamagic feat.
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
	   nDuration = nDuration *2;	//Duration is +100%
    }
    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_MAGIC_CIRCLE_AGAINST_EVIL, FALSE));

    //Create an instance of the AOE Object using the Apply Effect function
    //JXApplyEffectToObject(DURATION_TYPE_INSTANT, eVis2, oTarget);
    JXApplyAreaEffectToObject(AOE_MOB_CIRCGOOD, oTarget, HoursToSeconds(nDuration));

	JXPostSpellCastCode();
}
