//::///////////////////////////////////////////////
//:: Aura of Despair
//:: NW_S2_AuraDespair.nss
//:: Copyright (c) 2006 Obsidian Entertainment, Inc.
//:://////////////////////////////////////////////
/*
	Blackguard supernatural ability that causes all
	enemies within 10' to take a -2 penalty on all saves.
*/
//:://////////////////////////////////////////////
//:: Created By: Andrew Woo (AFW-OEI)
//:: Created On: 05/30/2006
//:://////////////////////////////////////////////
#include "nw_i0_spells"
#include "jx_inc_magic"
#include "x2_inc_spellhook"

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        { JXPostSpellCastCode(); return; }
    }

    object oTarget = JXGetSpellTargetObject();

	// Strip any Protective Auras first
	//RemoveSpellEffects(SPELLABLILITY_AURA_OF_DESPAIR, OBJECT_SELF, oTarget);
	
	//Create an instance of the AOE Object using the Apply Effect function
	// AFW-OEI 08/30/2006: Only apply effects if you don't already have them.
	//	The RemoveSpellEffects brute-force call was causing problems with effect icons.
	if (!GetHasSpellEffect(SPELLABLILITY_AURA_OF_DESPAIR, OBJECT_SELF))
	{
		SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELLABLILITY_AURA_OF_DESPAIR, FALSE));
	    JXApplyAreaEffectToObject(AOE_PER_AURA_OF_DESPAIR, oTarget);
	}

	JXPostSpellCastCode();
}
