//::///////////////////////////////////////////////
//:: War Glory
//:: NW_S2_WarGlory.nss
//:: Copyright (c) 2006 Obsidian Entertainment, Inc.
//:://////////////////////////////////////////////
/*
    Grants a bonus to hit to allies and penalties
	to saves for enemies.
*/
//:://////////////////////////////////////////////
//:: Created By: Andrew Woo (AFW-OEI)
//:: Created On: 05/19/2006
//:://////////////////////////////////////////////
#include "nw_i0_spells"
#include "jx_inc_magic"
#include "x2_inc_spellhook"

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        { JXPostSpellCastCode(); return; }
    }

    object oTarget = JXGetSpellTargetObject();

	// Strip any Protective Auras first
	//RemoveSpellEffects(SPELLABILITY_WAR_GLORY, OBJECT_SELF, oTarget);
	
	//Create an instance of the AOE Object using the Apply Effect function
	// AFW-OEI 09/21/2006: Only apply effects if you don't already have them.
	//	The RemoveSpellEffects brute-force call was causing problems with effect icons.
	if (!GetHasSpellEffect(SPELLABILITY_WAR_GLORY, OBJECT_SELF))
	{
		SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELLABILITY_WAR_GLORY, FALSE));
	    JXApplyAreaEffectToObject(AOE_PER_WAR_GLORY, oTarget);
	}

	JXPostSpellCastCode();
}
