//::///////////////////////////////////////////////
//:: Wild Mage Spell - Hornung's Baneful Deflector
//::///////////////////////////////////////////////
/*
Description modified from AD&D 2nd Edition - "Tome of Magic"

Hornung’s Baneful Deflector 

Caster Level(s): Wizard / Sorcerer 3
Innate Level: 3
School: Evocation
Descriptor(s): Wild Magic
Component(s): Verbal, Somatic
Range: Touch
Area of Effect / Target: Single Creature
Duration: 2 rounds/level
Save: None
Spell Resistance: No

     This spell surrounds the recipient in a shimmering, 
hemispherical field of force. The field is transparent and 
moves with the subject, forming a shell about one foot away 
from his body. The shell serves as a shield against all 
forms of individually targeted missile attacks (including 
the spells, Magic Missile, Melf’s Acid Arrow, Flame Arrow, 
and Quill Fire).  The Spell will deflect enchanted missiles, 
but any additional effects such as fire damage will still 
strike the protected.
     Whenever an individual missile attack is directed at a 
protected creature, the baneful deflector activates. Instead 
of striking the target creature, the missile’s target is 
determined randomly among all creatures within a 30-foot 
hemisphere of the protected creature, including the 
protected creature. The missile then changes course toward 
its new target.  The new target must make a Reflex save vs. 
spells to avoid the projectile.

2d2f_sp_baneful_d.nss
*/
//::///////////////////////////////////////////////
//:: Created By: 2DruNk2Frag
//:: Created On: 02-18-2008
//:: Last Update: 03-22-2008
//::///////////////////////////////////////////////

#include "2d2f_includes"
#include "jx_inc_magic"
#include "x2_inc_spellhook" 
#include "jx_inc_magic_info"
#include "nwn2_inc_spells"
#include "nw_i0_spells"



void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
	object oCaster = JXGetCaster();
	int nWMLvl = GetLevelByClass(CLASS_WILDMAGE, oCaster);
	if((nWMLvl >= 3) || (GetObjectType(oCaster) == OBJECT_TYPE_PLACEABLE))
	{
/* 
  Spellcast Hook Code 
  Added 2003-06-23 by GeorgZ
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more
  
*/

    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        { JXPostSpellCastCode(); return; }
    }
	//:://////////////////////////////////////////
	
	int nLvl = JXGetCasterLevel();
	int nDur = 2 * nLvl;
	float fDuration = RoundsToSeconds(nDur);
	fDuration = ApplyMetamagicDurationMods(fDuration);
    int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);
	
	effect eVis = EffectVisualEffect(VFX_DUR_BANEFUL_D);
	effect eProt = EffectDamageReduction(100, DAMAGE_POWER_NORMAL, 0, DR_TYPE_NON_RANGED);
	effect eLink = EffectLinkEffects(eVis,eProt);
	   	
	JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oCaster, fDuration);
	
	JXApplyAreaEffectToObject(AOE_PER_BANEFUL_D, oCaster, fDuration,"2d2f_sp_baneful_d_enter","2d2f_sp_baneful_d_heart", "");
	
	SetLocalInt(oCaster,"nBanefulSpellId",JXGetSpellId());
	SetLocalInt(oCaster,"nHasBanefulD",1);
	
	DelayCommand(fDuration, DeleteLocalInt(oCaster,"nBanefulSpellId"));
	DelayCommand(fDuration, DeleteLocalInt(oCaster,"nHasBanefulD"));

	}
	else
	{
	SendMessageToPC(oCaster, "You must be at least a level 3 Wild Mage to use this spell");
	}
	
	
	JXPostSpellCastCode();
	return;
}