//::///////////////////////////////////////////////
//:: Wild Mage Spell - Paithan's Fiasco
//::///////////////////////////////////////////////
/*

Paithan’s Fiasco

Caster Level(s): Wizard / Sorcerer 4
Innate Level: 4
School: Enchantment
Descriptor(s): Wild Magic
Component(s): Verbal, Somatic
Range: Touch
Area of Effect / Target: One Creature
Duration: Special
Save: None
Spell Resistance: Yes

!!! This is a Wild Magic Spell and can only be cast by a Wild Mage !!!

     This spell is the reverse of Paithan’s Lucky Streak (Level 3).  The recipient has an 
unfortunate run of bad luck.  The caster must make a successful melee touch attack against 
the target. If successful, each round a random penalty from 0-3 is individually calculated 
and subtracted from the following; all saves, attack rolls, all skills, and armor class 
(dodge).  If the target of Paithan’s Lucky Streak is the victim of a wild surge, a random 
penalty of 0 - 6 is subtracted from the wild surge table increasing the likelihood of a 
negative result.
     Each round of Paithan’s Fiasco a d20 is rolled to determine its course.  If a 1 or 2 is 
rolled the spell ends immediately due to good luck luck.  However, if a 20 is rolled for 
that round the target extremely doomed and receives a penalty of 6 on all his actions and 12 
to any wild surge results.
     The duration of Paithan’s Fiasco is indefinite.  It can continue as long as the target 
does not have good luck by rolling a 1 or 2.


2d2f_sp_fiasco.nss
*/
//::///////////////////////////////////////////////
//:: Created By: 2DruNk2Frag
//:: Created On: 04-05-2008
//:: Last Update: 04-05-2008
//::///////////////////////////////////////////////

#include "2d2f_includes"
#include "jx_inc_magic"
#include "x2_inc_spellhook" 
#include "jx_inc_magic_info"
#include "nwn2_inc_spells"
#include "nw_i0_spells"



void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
	object oCaster = JXGetCaster();
	int nWMLvl = GetLevelByClass(CLASS_WILDMAGE, oCaster);
	if((nWMLvl >= 5) || (GetObjectType(oCaster) == OBJECT_TYPE_PLACEABLE))
	{
/* 
  Spellcast Hook Code 
  Added 2003-06-23 by GeorgZ
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more
  
*/

    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        { JXPostSpellCastCode(); return; }
    }
	//:://////////////////////////////////////////
	
	object oTarget = JXGetSpellTargetObject();
	SetLocalObject(oCaster, "oFiascoTarget", oTarget);
	
	int nTouch = TouchAttackMelee(oTarget);
	
	if (nTouch > 0)
	{
		if (!MyResistSpell(OBJECT_SELF, oTarget))
	   	{
	
			int nRandPenalty1 = d4(1) - 1;
			int nRandPenalty2 = d4(1) - 1;
			int nRandPenalty3 = d4(1) - 1;
			int nRandPenalty4 = d4(1) - 1;
			int nRandPenalty5 = d4(1) - 1;
		
			
			effect eVisHit = EffectVisualEffect(VFX_HIT_SPELL_ENCHANTMENT);
				
			effect eEffectIconBase = EffectVisualEffect(VFX_DUR_LIGHT_PURPLE_5);
			effect eEffectIcon = EffectEffectIcon(EFFECT_ICON_FIASCO);
			effect eScale = EffectSetScale(1.0);
			effect eLinkEffectIcon = EffectLinkEffects(eEffectIconBase,eEffectIcon);
			eLinkEffectIcon = EffectLinkEffects(eLinkEffectIcon,eScale);
			eLinkEffectIcon = SetEffectSpellId(eLinkEffectIcon,SPELL_FIASCO);
				
			effect eIcon = EffectVisualEffect(VFX_FIASCO_ICON);
			eIcon = SetEffectSpellId(eIcon,SPELL_FIASCO);
			
			effect eHit = EffectAttackDecrease(nRandPenalty1);
			effect eSave = EffectSavingThrowDecrease(SAVING_THROW_ALL,nRandPenalty2);
			effect eSkill = EffectSkillDecrease(SKILL_ALL_SKILLS,nRandPenalty3);
			effect eAC = EffectACDecrease(nRandPenalty4);
			effect eLink = EffectLinkEffects(eHit,eSave);
			eLink = EffectLinkEffects(eLink,eSkill);
			eLink = EffectLinkEffects(eLink,eAC);
						
			SetLocalInt(oTarget,"nPiathansModifier", nRandPenalty5 * -2);
			
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_LUCKY_STREAK, FALSE));
			
			JXApplyAreaEffectToObject(AOE_PER_CUSTOM_AOE,oTarget,0.0,"","2d2f_sp_fiasco_heart","");
			JXApplyEffectToObject(DURATION_TYPE_INSTANT, eVisHit, oTarget);
			JXApplyEffectToObject(DURATION_TYPE_PERMANENT, eLinkEffectIcon, oTarget);
			JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget,RoundsToSeconds(1));
			JXApplyEffectToObject(DURATION_TYPE_PERMANENT, eIcon, oTarget);
			
		}
	}
	
	}
	else
	{
	SendMessageToPC(oCaster, "You must be at least a level 5 Wild Mage to use this spell");
	}
	
	
	JXPostSpellCastCode();
	return;
}