//::///////////////////////////////////////////////
//:: Wild Mage Spell - Paithan's Lucky Streak Heart script
//::///////////////////////////////////////////////
/*

Paithan’s Lucky Streak

Caster Level(s): Wizard / Sorcerer 3
Innate Level: 3
School: Enchantment
Descriptor(s): Wild Magic
Component(s): Verbal, Somatic
Range: Touch
Area of Effect / Target: One Creature
Duration: Special
Save: None
Spell Resistance: No

!!! This is a Wild Magic Spell and can only be cast by a Wild Mage !!!

     This spell gives the recipient an incredible streak of luck.  Each round a random bonus 
from 0-3 is individually calculated and added to the following; all saves, attack rolls, all 
skills, and armor class (dodge).  If the benefactor of Paithan’s Lucky Streak is the victim 
of a wild surge, a random bonus of 0 - 6 is added to the wild urge table increasing the 
likelihood of a positive result.
     Each round of Paithan’s Lucky Streak a d20 is rolled to determine its course.  If a 1 
or 2 is rolled the spell ends immediately due to bad luck.  However, if a 20 is rolled for 
that round the target has extremely good luck and receives a bonus of 6 on all his actions 
and 12 to any wild surge results.
     The duration of Paithan’s Lucky streak is indefinite.  It can continue as long as the 
target does not have bad luck by rolling a 1 or 2.

2d2f_sp_lucky_streak_heart.nss
*/
//::///////////////////////////////////////////////
//:: Created By: 2DruNk2Frag
//:: Created On: 03-11-2008
//:: Last Update: 03-11-2008
//::///////////////////////////////////////////////

#include "2d2f_includes"
#include "jx_inc_magic"
#include "x2_inc_spellhook" 
#include "jx_inc_magic_info"
#include "nwn2_inc_spells"
#include "nw_i0_spells"

void main()
{
		object oCaster = JXGetAOERealCreator();//GetFirstPC();
		object oTarget = GetLocalObject(oCaster,"oLuckyTarget");
		float fDur = RoundsToSeconds(1);
		
		int nRandStreak = d20(1);
		
		int nRandBonus1 = d4(1) - 1;
		int nRandBonus2 = d4(1) - 1;
		int nRandBonus3 = d4(1) - 1;
		int nRandBonus4 = d4(1) - 1;
		int nRandBonus5 = d4(1) - 1;
		
		if(GetIsDead(oTarget) || 
		!GetIsObjectValid(oTarget) || 
		GetIsResting(oTarget) == TRUE)
    	{
			DestroyObject(OBJECT_SELF,0.0);
			RemoveSpellEffects(SPELL_LUCKY_STREAK, oCaster, oTarget);
			DeleteLocalInt(oTarget,"nPiathansModifier");
			DeleteLocalObject(oCaster,"oLuckyTarget");
			return;
    	}		
		
		if(nRandStreak == 1)
		{
			DestroyObject(OBJECT_SELF,0.0);
			RemoveSpellEffects(SPELL_LUCKY_STREAK, oCaster, oTarget);
			DeleteLocalInt(oTarget,"nPiathansModifier");
			DeleteLocalObject(oCaster,"oLuckyTarget");
			return;
		}
		else if(nRandStreak == 2)
		{			
			effect eHit = EffectAttackDecrease(1);
			effect eSave = EffectSavingThrowDecrease(SAVING_THROW_ALL,1);
			effect eSkill = EffectSkillDecrease(SKILL_ALL_SKILLS,1);
			effect eAC = EffectACDecrease(1);
			effect eLink = EffectLinkEffects(eHit,eSave);
			eLink = EffectLinkEffects(eLink,eSkill);
			eLink = EffectLinkEffects(eLink,eAC);
			
			SetLocalInt(oTarget,"nPiathansModifier", -2);
			
			JXApplyEffectToObject(DURATION_TYPE_TEMPORARY,eLink,oTarget,fDur);
			return;
		}
		else if(nRandStreak == 20)
		{
			nRandBonus1 = 6;
			nRandBonus2 = 6;
			nRandBonus3 = 6;
			nRandBonus4 = 6;
			nRandBonus5 = 6;
		}	
		
		
		effect eHit = EffectAttackIncrease(nRandBonus1);
		effect eSave = EffectSavingThrowIncrease(SAVING_THROW_ALL,nRandBonus2);
		effect eSkill = EffectSkillIncrease(SKILL_ALL_SKILLS,nRandBonus3);
		effect eAC = EffectACIncrease(nRandBonus4);
		effect eLink = EffectLinkEffects(eHit,eSave);
		eLink = EffectLinkEffects(eLink,eSkill);
		eLink = EffectLinkEffects(eLink,eAC);
		
		SetLocalInt(oTarget,"nPiathansModifier", nRandBonus5 * 2);
		
		JXApplyEffectToObject(DURATION_TYPE_TEMPORARY,eLink,oTarget,fDur);
		
	
}