//:: Wild Mage Spell - Mass Magical Propensity Modifier Exit Script
//::///////////////////////////////////////////////
/*
Mass Magical Propensity Modifier

Caster Level(s): Wizard / Sorcerer 7
Innate Level: 7
School: Divination
Descriptor(s): Wild Magic
Component(s): Verbal, Somatic
Range: Caster
Area of Effect / Target: 60’ diameter sphere
Duration: 1d4 + 1 round / 4 caster levels
Save: None
Spell Resistance: Yes

!!! This is a Wild Magic Spell and can only be cast by a Wild Mage !!!

    Mass Magical Propensity Modifier is in many ways similar to the 4th level single target 
version except for a few key differences.  First, every creature within 30 feet of the 
caster (including the caster) is affected by the spell.  Second, all saves against spells are 
modified for the duration of the spell.  Each round within the area of effect a new modifier 
is calculated for each individual creature.  Third, once the spell expires the effect of the 
spell is removed from the target creature and they will make their saving throws normally.
     This powerful and risky spell may just be what it takes to turn the tide of battle to 
the favor of the Wild Mage.  However, nothing is certain with wild magic and Mass Magical 
Propensity Modifier may become a recipe for the caster’s demise.


2d2f_sp_mass_propensity_exit.nss
*/
//::///////////////////////////////////////////////
//:: Created By: 2DruNk2Frag
//:: Created On: 04-14-08
//:: Last Update: 04-14-08
//::///////////////////////////////////////////////

#include "2d2f_includes"
#include "jx_inc_magic"
#include "x2_inc_spellhook" 
#include "jx_inc_magic_info"
#include "nwn2_inc_spells"
#include "nw_i0_spells"

void main()
{
	object oTarget = GetExitingObject();
    int bValid = FALSE;
    effect eAOE;
    if(GetHasSpellEffect(SPELL_MASS_PROPENSITY_MODIFIER, oTarget))
    {
		//Search through the valid effects on the target.
        eAOE = GetFirstEffect(oTarget);
        while (GetIsEffectValid(eAOE))
        {
            if (GetEffectCreator(eAOE) == GetAreaOfEffectCreator())
            {
                //If the effect was created by the AOE then remove it
                if(GetEffectSpellId(eAOE) == SPELL_MASS_PROPENSITY_MODIFIER)
                {
                    RemoveEffect(oTarget, eAOE);
					object oPC = GetFirstPC();
					DeleteLocalInt(oTarget,"nPropensityModifier");
					DeleteLocalObject(oTarget,"oPropensityCaster");
				}
            }
            //Get next effect on the target
            eAOE = GetNextEffect(oTarget);
        }
    }



}