//::///////////////////////////////////////////////
//:: Wild Mage Spell - Mass Magical Propensity Modifier
//::///////////////////////////////////////////////
/*
Mass Magical Propensity Modifier

Caster Level(s): Wizard / Sorcerer 7
Innate Level: 7
School: Divination
Descriptor(s): Wild Magic
Component(s): Verbal, Somatic
Range: Caster
Area of Effect / Target: 60’ diameter sphere
Duration: 1d4 + 1 round / 4 caster levels
Save: None
Spell Resistance: Yes

!!! This is a Wild Magic Spell and can only be cast by a Wild Mage !!!

    Mass Magical Propensity Modifier is in many ways similar to the 4th level single target 
version except for a few key differences.  First, every creature within 30 feet of the 
caster (including the caster) is affected by the spell.  Second, all saves against spells are 
modified for the duration of the spell.  Each round within the area of effect a new modifier 
is calculated for each individual creature.  Third, once the spell expires the effect of the 
spell is removed from the target creature and they will make their saving throws normally.
     This powerful and risky spell may just be what it takes to turn the tide of battle to 
the favor of the Wild Mage.  However, nothing is certain with wild magic and Mass Magical 
Propensity Modifier may become a recipe for the caster’s demise.



2d2f_sp_mass_propensity_modifier.nss
*/
//::///////////////////////////////////////////////
//:: Created By: 2DruNk2Frag
//:: Created On: 04-13-08
//:: Last Update: 04-13-08
//::///////////////////////////////////////////////

#include "2d2f_includes"
#include "jx_inc_magic"
#include "x2_inc_spellhook" 
#include "jx_inc_magic_info"
#include "nwn2_inc_spells"
#include "nw_i0_spells"



void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
	object oCaster = JXGetCaster();
	int nWMLvl = GetLevelByClass(CLASS_WILDMAGE, oCaster);
	if((nWMLvl >= 11) || (GetObjectType(oCaster) == OBJECT_TYPE_PLACEABLE))
	{
/* 
  Spellcast Hook Code 
  Added 2003-06-23 by GeorgZ
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more
  
*/

    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        { JXPostSpellCastCode(); return; }
    }
	//:://////////////////////////////////////////
	
	object oTarget = JXGetSpellTargetObject();
	int nLvl = JXGetCasterLevel();
	
	int nDur = d4(1) + (nLvl / 4);
	float fDuration = RoundsToSeconds(nDur);
	
	fDuration = ApplyMetamagicDurationMods(fDuration);
    int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);
	
	effect eVis = EffectVisualEffect(VFX_DUR_PROPENSITY_AOE);
	
	JXApplyEffectToObject(nDurType,eVis,oCaster,fDuration);
	JXApplyAreaEffectToObject(AOE_PER_PROPENSITY,oCaster,fDuration,"2d2f_sp_mass_propensity_enter",
																	"2d2f_sp_mass_propensity_heart",
																	"2d2f_sp_mass_propensity_exit");
	
	}																
	else
	{
	SendMessageToPC(oCaster, "You must be at least a level 11 Wild Mage to use this spell");
	}
	
		JXPostSpellCastCode();
	return;
}